VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Delta Time (gioco)"
   ClientHeight    =   2055
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6210
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2055
   ScaleWidth      =   6210
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer3 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   5640
      Top             =   240
   End
   Begin VB.TextBox txt_DeltaTime 
      Height          =   375
      Left            =   3360
      TabIndex        =   1
      Top             =   840
      Width           =   2055
   End
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   2000
      Left            =   1560
      Top             =   1320
   End
   Begin VB.CommandButton cmd_Intercetta 
      Caption         =   "Stoppa !!"
      Height          =   375
      Left            =   3360
      TabIndex        =   0
      Top             =   240
      Width           =   2055
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   960
      Top             =   1320
   End
   Begin VB.Label Label2 
      BackColor       =   &H00E0E0E0&
      Caption         =   "Tentativo n:  "
      Height          =   375
      Left            =   3480
      TabIndex        =   3
      Top             =   1440
      Width           =   1935
   End
   Begin VB.Label Label1 
      BackColor       =   &H000FF000&
      BorderStyle     =   1  'Fixed Single
      Height          =   975
      Left            =   120
      TabIndex        =   2
      Top             =   240
      Width           =   3015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' -----------------------------------------------------------------
' A. Veneziani - Misuratore di riflessi
'
'                (versione base semplificata)
'
' -----------------------------------------------------------------


Option Explicit

Dim Ritardo As Integer     ' ritardo casuale con cui appare il rosso
Dim NumTick As Integer       ' numero di tick effettuati dal timer che conta il ritardo di risposta (Timer3)
Dim Tentativi As Integer   ' numero di tentativi complessivi

' pulsante di reazione dell'utente
Private Sub cmd_Intercetta_Click()
    Timer3.Enabled = False         ' stoppa Timer3 ossia il conteggio del ritardo
    txt_DeltaTime.Text = NumTick * Timer3.Interval & "  ms."   ' dal numero di tick contati deduce il tempo di ritardo
    NumTick = 0  ' azzera conteggio tempo Timer3
End Sub

' all' inizio...
Private Sub Form_Load()
    Tentativi = 0     ' azzera conteggio tentativi
    Randomize           ' inizializza generatore casuale per produrre effettivamente random
    Ritardo = Rnd * 10     ' crea un numero entro 10 (sec.)
    Ritardo = Int(Ritardo * 1000)   ' (converte il tutto in ms.)
     
    Timer1.Enabled = True       ' attiva il timer che genera i *** ritardi variabili del rosso ***
    Timer1.Interval = Ritardo     ' imposta il ritardo su Timer1
    
End Sub

' appena termina il periodo di ritardo variabile in cui apparir il rosso
' vengono attivati Timer2 (f permanere il rosso per 2 secondi)
' e Timer3 (inzia subito a registrare il tempo di risposta al rosso dell'utente
Private Sub Timer1_Timer()
    Timer2.Enabled = True
    Timer3.Enabled = True
    Timer1.Enabled = False
    
    ' cambia l'etichetta da verde a rossa
    Label1.BackColor = vbRed
    Tentativi = Tentativi + 1        ' registra che un nuovo tentativo  in corso
    Label2.Caption = "Tentativo n:  " & Tentativi   ' aggiorna la label cheindica a che tentativo siamo
    txt_DeltaTime.Text = ""
End Sub

' fa' permanere il rosso per x secondi
Private Sub Timer2_Timer()
    ' quando termina il periodo in cui  visibile il rosso
    ' imposta i parametri di ritardo per un nuovo tentativo
    Ritardo = Rnd * 10
    Ritardo = Int(Ritardo * 1000)
    
    ' attiva il timer per il ritardo casuale del rosso (Timer1) e spegne Timer2
    ' che ha terminato, per il momento il suo compito
    Timer1.Enabled = True
    Timer1.Interval = Ritardo
    Timer2.Enabled = False
    Timer3.Enabled = False   ' stoppa il timer 3 (conteggio del tempo passato sul rosso)
    NumTick = 0                 ' azzera il conteggio (la label e' attualmente di nuovo verde)
    
    Label1.BackColor = vbGreen     ' f riapparire, ovviamente, il verde
End Sub

Private Sub Timer3_Timer()
    NumTick = NumTick + 1     ' conteggio del numero di tick da 10 ms. l'uno
End Sub

